stages:
    - build
    - test
    - deploy
    - performance
    - deploy_prod

include:
    - template: Verify/Load-Performance-Testing.gitlab-ci.yml
    - template: Security/SAST.gitlab-ci.yml


default:
    image: node:14

variables:
    DOMAIN_TEST: ec_dom_38-test.surge.sh
    DOMAIN_PROD: ec_dom_38-prod.surge.sh

load_performance:
    variables:
        K6_TEST_FILE: test.js

        
build:
    stage: build
    script:
        - npm ci
        - npm run build
        - echo "run build"

    artifacts:
        paths:
            - public/
    cache:
        key: master
        paths:
            - node_modules/

test build:
    stage: test
    image: alpine:latest
    script:
        - grep "build something great" ./public/index.html

test server:
    stage: test
    script:
          - npm run serve &
          - sleep 10
          - curl http://localhost:9000 | tac | tac | grep -q "build something great"
    cache:
        key: master
        paths:
            - node_modules/
        policy: pull


deploy test:
    stage: deploy
    script:
        - npx surge --project ./public --domain $DOMAIN_TEST
    environment:
        name: test
        url: http://$DOMAIN_TEST
        on_stop: stop test
    only:
        - master

stop test:
    stage: deploy
    script: npx surge teardown $DOMAIN_TEST
    environment:
        name: test
        action: stop
    when: manual

deploy prod:
    stage: deploy_prod
    script:
        - npx surge --project ./public --domain $DOMAIN_PROD
    when: manual
    environment:
        name: production
        url: http://$DOMAIN_PROD
    only:
       - master



        

